HWeb - Feature #252

Template parser - if statements & for loops
2011-06-29 09:32 - Jacko Hoogeveen

Status: Closed Start date: 2011-06-29
Priority: Normal Due date:

Assignee: Elmer de Looff % Done: 100%
Category: TemplateParser Estimated time: 0.00 hour
Target version: Spent time: 12.50 hours
Description

If statements and for loops in the templates.

Example if (jango style):

<body>
{%$ 1if varl %}
<div>
Lorem Ipsum
</div>
{% elseif var2 %}
<div>
Lorem Ipsum
</div>
{% endif %}
</body>

Example for (jango style):

<ul>

{% for athlete in athlete_list %}
<1i>{{ athlete.name }}</1i>

{% endfor %}

</ul>

Related issues:
Related to uyWeb - Feature #61: Template parser - default values Closed 2011-05-02

Associated revisions

Revision 3175:2380457fc7f5 - 2011-12-08 18:48 - ElImer de Looff

Added first testcase checking the behaviour of FOR-loops: Test succeeds! Declaring v1.0 of templateparser. Lots of code cleanup still needed before
we can merge this, but this resolves #252.

Revision 118:6df048aa7fcd - 2011-12-08 18:48 - EImer de Looff

Added first testcase checking the behaviour of FOR-loops: Test succeeds! Declaring v1.0 of templateparser. Lots of code cleanup still needed before
we can merge this, but this resolves #252.

Revision 3300:€85529599039 - 2012-01-10 18:03 - EImer de Looff

Added {{ if }} statements to the templateparser. This allows richer expressions in templates. if, elif and else are properly supported. This completely
resolves #252 and makes obsolete issue #61.
Revision 157:83666f9b5d14 - 2012-01-10 18:03 - Elmer de Looff

Added {{ if }} statements to the templateparser. This allows richer expressions in templates. if, elif and else are properly supported. This completely
resolves #252 and makes obsolete issue #61.

History

#1 - 2011-06-29 11:13 - Jan Klopper

Im still not sure If we'd want this.
Yes, it would make the pagemakers less intricate. But meh, if's in templates just make it possible to have too much logic in there.

Loops are less of a problem imho, however There needs to be a pretty good and clean syntax.

#2 - 2011-06-29 11:26 - EImer de Looff

This would upgrade the 'dumb template' to an actual View (as in, MVC). I'm not sure this is a bad idea, actually, | think it's a good idea. Currently we
have a huge amalgamation of little template snippets that aren't really super useful imo.

For loops are a 'requirement’ for the future | would say. I've less strong feelings about if/else structures, but it might make sense to toss out defaults in
favor of them.

#3 - 2011-09-23 15:21 - EImer de Looff

- Category set to TemplateParser

#4 - 2011-12-08 18:48 - EImer de Looff
- Status changed from New to Resolved

- % Done changed from 0 to 70

For-loops have been added to the templateparser in a separate branch of the Underdark repository. The merge is pending more extensive testing and
a good bit of code-cleanup and thorough documentation.

Example template:

<html>
<body>
<ul>
{{ for person in [names] }}
<li>Hello [person]</1li>
{{ endfor }}
</ul>
</body>
</html>

When this template is parsed with names=("Tom', 'Dick’, 'Harry'), the output will be (barring copious whitespace differences):

<html>
<body>
<ul>
<li>Hello Tom</li>
<li>Hello Dick</1li>
<li>Hello Harry</li>
</ul>
</body>
</html>
#5 - 2011-12-09 20:07 - EImer de Looff
- Status changed from Resolved to Closed

- % Done changed from 70 to 100

All relevant tests and documentation has been added, and the development branch has been merged in to the production branch.

#6 - 2012-01-10 18:07 - EImer de Looff

{{ if }} statement now included in templateparser. For a minor example, refer to issue #61.
https://bugs.underdark.nl/issues/61
http://www.tcpdf.org

